Attribute VB_Name = "FunkceNF"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'      Popis: Demonstan funkce ukazujc zkladn operace s Navision Financials
'
'    Pouit:
'
'      Autor: Tom vec
'
' References: FinX
'               - CFRONT.OCX
'
' Upozornn: Zde uveden funkce pouze demonstruj pouit knihovny FinX a pestoe
'             pro mnoho ppad je lze pout "tak jak jsou" tak se nejedn
'             o univerzln a pln funkn nstroje.
'             Kad implementace Navision Financials je specifick a na druhou stranu
'             ani pouit knihovny FinX se zdaleka neomezuje na tch nkolik mlo
'             zde naznaench operac.
'             Pro komunikaci s Navision Financials a pouit FinX vbec je nutn
'             alespo pimen znalost Navision Financials a jeho vnitnch vazeb!
'
'   Historie:
'             27.11.2000 - zahjen vvoje
'             16.12.2000 - Uesn, okomentovn a vydn betaverze
'
'       ToDo: - pravy a zakldn karet zbo
'             - Budouc verze FinX (1.1)
'                - POZOR!!!! nebude obsahovat objekty nfTableXXX, ale msto toho
'                  bude "standardnm zpsobem" (jako v NF) obsahovat funkci VALIDATE
'                  (Kd vak bude implementovn pouze pro nkter tabulky)
'                - Podpora Microsoft Message Queuing (MSMQ) pro zpisov operace
'                  Jet je otzka zda pmo nebo prostednictvm dalho severu,
'                  kter bude zpracovvat zprvy.
'                - Specifikace umstn licennho souboru (Fin.flf)
'                - Funkce CalcDate
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Objekt FinX ke svoj funkci potebuje nkolik dalch soubor,
' kter jsou soust instalace Navision Financials
'
'  cfront.dll  C/FRONT C-API library
'  cfront.ocx  C/FRONT OCX
'
'  dbm.dll     NF database engine
'  nc_netb.dll knihovna pro komunikaci se serverem pomoc NetBiosu
'  nc_tcp.dll  knihovna pro komunikaci se serverem pomoc TCP/IP
'  slave.exe   pravdpodobn sprva cache
'  fin.etx     soubor obsahujc systmov chybov hlky -lokalizovan
'  fin.stx     zkladn parametry a konstanty NF - lokalizovan
'  fin.flf     Licenn soubor - mus podporovat verzi NF 2.60
'              a mus obsahovat oprvnn pro C/FRONT (granule 1800)
'
'  mfc42.dll   Microsoft Foundation Classes Library (soust Win)
'  msvcrt.dll  Microsoft Visual C Run-Time Library  (soust Win)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit
Global NF As FinX.Database
Global clsIniFile As New clsIniFile

Public Type ProdHlav
  'Zjednoduen struktura pro vloen objednvky
  DocumentType As Integer 'Nabdka,Objednvka,Faktura,Dobropis,Hromadn objednvka
  No As String 'Povinn! Mus bt vyplnno
  Sell_toCustomerNo As String 'selnk NF, Povinn! slo (ID) zkaznka
  
  Bill_toName As String
  Bill_toName2 As String
  Bill_toContact As String
  Bill_toAddress As String
  Bill_toAddress2 As String
  Bill_toCity As String
  Bill_toPostCode As String
  VATRegistrationNo As String
  Gen_Bus_PostingGroup As String
  VATBus_PostingGroup As String
  CustomerPostingGroup As String
  
  Ship_toName As String
  Ship_toName2 As String
  Ship_toContact As String
  Ship_toAddress As String
  Ship_toAddress2 As String
  Ship_toCity As String
  Ship_toPostCode As String
  
  OrderDate As Date 'Datum vzniku objednvky
  ShipmentDate As Date 'Pedpokldan datum dodn
  DatumSplatnosti As Date 'Datum kdy m zkaznk zaplatit. Systm me datum zmnit. M smysl pouze u prodeje "na fakturu".
  
  ShipmentMethodCode As String 'selnk NF - Dleit!!!
  PaymentTermsCode As String 'selnk NF - Dleit!!!
  
  SalespersonCode As String 'selnk NF
  
  
  LocationCode As String 'selnk NF
  DepartmentCode As String 'selnk NF
  ProjectCode As String 'selnk NF
  '-------------------------------------------
  PlatceICO As String  'Only for Czech Version
  '-------------------------------------------
  DatumExpirace As Date 'Datum kdy objednvka vypadne z fronty k runmu doeen (TimeOut) - Pouze CP
  DodaciTelefon As String 'Kontakt "Jak se k nm dostanete?" - tiskne doklady pro pepravn slubu
  KodVyrizuje As String 'selnk NF - Pouze CP
End Type

Public Type ProdRadek
'Zjednoduen struktura pro vloen dku objednvky
'Funkce InsertProdR zajisti vloen daj ve sprvnm poad

  LineNo As Long
  Type_ As Integer
  No As String
  Quantity As Double
  UnitPrice As Currency
  UnitPriceIncludesVAT As Boolean
  AmountIncludingVAT As Currency
  Description As String
  LocationCode As String
  DepartmentCode As String
  ProjectCode As String
End Type

Public Type Zbozi
'Zjednoduen struktura pro vloen karty zbo
'Funkce InsertZbozi zajisti vloen daj ve sprvnm poad

  No As String                'Povinn
  Name As String
  UnitPrice As Currency
  UnitPriceIncludesVAT As Boolean
  UnitListPrice As Currency
  NetWeight As Double
  GrossWeight As Double
  
  Gen_Prod_PostingGroup As String       'Povinn - selnk NF - Dleit!!!
  VATProd_PostingGroup As String        'Povinn - selnk NF - Dleit!!!
  InventoryPostingGroup As String       'Povinn - selnk NF - Dleit!!!
  VATBus_PostingGr_Price As String      'selnk NF
  
  VendorNo As String      'selnk NF
  VendorItemNo As String  'slo pod kterm zbo eviduje dodavatel
  
  No2 As String               'V CP pejmenovno a pouito jako "rov kd"
  SearchName As String        'V CP pejmenovno a pouito jako ISBN
  '-----------------------------------------------------------------------------
  IDVltava As String             'Pouze CP
End Type

Public Function OrderChanged(nfProdHl As FinX.Table)
  'Funkce je zavolna pokad kdy je detekovna njak zmna na objednvce.
  'Je poteba potat s mnoha faktory:
  ' - zmna mohla bt nevznamn a tedy nerozpoznateln
  '   (nap. Jmno se zmnilo na to sam jmno)
  ' - Funkce me bt volna nkolikrt bez zjevnho dvodu (eknme "pouze pro jistotu")
  ' - Nkolik zmn za sebou mezi jednotlivmi testy bude detekovno jako zmna jedin.
  ' - Nkter zmny nemus bt zjitny vbec.
  '   Pokud njak modul NF objednvku zmn ani by zmnil jej pznak tak zmna nebude rozpoznna.
  '   Doporuuji obas preventivn obas projt vechny "nevyzen" objednvky.
  ' - Nen detekovno vloen objednvky tmto programem - potvrzen o importu se mus zajistit jinde
  ' - Nen rozeznno smazn objednvky. Pro systm prost zmiz!
  '---------------------------------------------------------------------------------------------------
  Debug.Print "Order " & nfProdHl(3) & " is changed"
End Function

Public Function OrderSuccess(ByVal OrderID As String)
  'Funkce je zavolna v ppad, e je detekovno pln vyzen objednvky
  'V praxi to znamen, e vnikla nov faktura a zrove ji neexistuje
  'objednvka ze kter tato faktura vznikla
  'Protoe objednvka ji neexistuje tak je pedno pouze jej slo.
  'POZOR!
  '  - Funkce me bt (pestoe to nedv smysl) zavolna nkolikrt.
  '  - Objednvka mohla bt vyzena sten a pot smazna.
  '    I to se povauje za vyzen.
  '-------------------------------------------------------------------------
  Debug.Print "Order " & OrderID & " id done"
End Function

Public Function InvoiceNew(nfSalesInvoiceH As FinX.Table)
  'Tato funkce se zavol pro kadou nov vytvoenou fakturu
  'Tie se pedpokld, e v systmu se nerozdluje dodvka od fakturace a e
  'vznik faktura zrove s dodacm listem. Jinmi slovy faktura obsahuje
  'pesn tot co dodac list.
  'Pravda to ale bt nemus. V tom ppad je nutn
  'sledovat i nov vznikl dodac listy.
  '-------------------------------------------------------------------------
  Debug.Print "New Invoice " & nfSalesInvoiceH(3)
End Function

Public Sub OrderTestChange()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'      Popis: Test zmny stav objednvek a faktur
'             Funkce pi detekci zmny vol funkce
'               - OrderChanged
'               - OrderSuccess
'               - InvoiceNew
'
'             Status kde funkce skonila si zapisuje do INI souboru
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  Dim nfProdHl As FinX.Table
  Dim nfSalesInvoiceH As FinX.Table
  Dim lngLastOrderVersion As Long
  Dim strLastInvoice As String
  Dim strMaxInvoice As String
  
  Set nfProdHl = NF.AllocTable(36) 'Prodejn hlavika
  Set nfSalesInvoiceH = NF.AllocTable(112) 'Hlavika prodejn faktury
  '---------------------------------------------------------------------------
  'Projdeme vechny nov faktury od poslednho testu
  strLastInvoice = clsIniFile.LoadFromINI("Counters", "LastInvoice")
  strMaxInvoice = clsIniFile.LoadFromINI("Counters", "MaxInvoice")
  
  If (strLastInvoice <> "") Or (strMaxInvoice <> "") Then
    Call nfSalesInvoiceH.SetFilter(3, ">" & strLastInvoice & "&<=" & strMaxInvoice) '"slo"
  End If
  
  If nfSalesInvoiceH.Find("-") Then
    Do
     Call InvoiceNew(nfSalesInvoiceH) 'Funkce zpracuje novou fakturu
     
     'Zjistme zda ji byla objednvka zcela vyzena
     If nfSalesInvoiceH(44) <> "" Then 'slo objednvky
       'Pokud faktura vznikla z objednvky ...
       If Not nfProdHl.GetRecT(CInt(1), nfSalesInvoiceH(44)) Then
         '... a Pokud ji tato objednvka neexistuje
         Call OrderSuccess(nfSalesInvoiceH(44)) 'Funkce zpracuje informaci o vyzen objednvky
       End If
     End If
     
    Loop While nfSalesInvoiceH.Find(">")
    Call clsIniFile.SaveToINI("Counters", "LastInvoice", nfSalesInvoiceH(3))
  End If
  
  '---------------------------------------------------------------------------
  'Projdeme vechny objednvky, kter byly zmnny od poslednho testu
  Call nfProdHl.SetCurrentKey(1, 50900) '"Typ dokladu","Verze zmn"
  Call nfProdHl.SetRange(1, 1) '"Typ dokladu",Objednvka
  lngLastOrderVersion = CLng("0" & clsIniFile.LoadFromINI("Counters", "LastOrderVersion"))
  Call nfProdHl.SetFilter(50900, ">" & lngLastOrderVersion) '"Test zmn"
  If nfProdHl.Find("-") Then
    Do
      Call OrderChanged(nfProdHl) 'Zavolme funkci, kter zpracuje zmnu
    Loop While nfProdHl.Find(">")
    Call clsIniFile.SaveToINI("Counters", "LastOrderVersion", nfProdHl(50900))
  End If
End Sub

Public Sub InsertProd(ByRef myHl As ProdHlav, ByRef myR() As ProdRadek)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'      Popis: Vlo do Navision Financials celou objednvku
'              - pokud v NF neexistuje zkaznk s uvedenm slem tak
'                bude jeho karta zaloena
'
'  Parametry: MyHl - daje pro Hlaviku objednvky
'             MyR  - Pole dk objednvky.
'                    Me jich bt teoreticky neomezen mnostv
'
'       ToDo: - Tato funkce by asi mla v ppad poteby zabezpeit
'               zatek a konec transakce (BWT-EWT) a ppadn i odchycen chyb
'               ke kterm me pri importu dojt.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  Dim I As Integer
  
  Call InsertProdHl(myHl)
  For I = 0 To UBound(myR) - 1
    If (myR(I).LineNo <> 0) Or (myR(I).No <> "") Then
      Call InsertProdR(myHl, myR(I))
    End If
  Next
  
End Sub

Public Sub InsertProdHl(ByRef myHl As ProdHlav)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'      Popis: Vlo do Navision Financials celou hlaviku objednvky
'
'  Parametry: MyHl - daje pro Hlaviku objednvky
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  'Dim nfSalesHeader As New FinX.nfTable36  'Prodejn hlavika
  'Dim nfCustomer As New FinX.nfTable18 'Zkaznk
  
  Dim nfSalesHeader As New FinX.Table
  Dim nfCustomer As New FinX.Table
  
  Set nfSalesHeader = NF.AllocTable(36)
  Set nfCustomer = NF.AllocTable(18)
  
  Call nfSalesHeader.Validate(tSalesHeader.DocumentType, myHl.DocumentType)
  Call nfSalesHeader.Validate(tSalesHeader.No, myHl.No)
  
  If Not nfCustomer.GetRecT(myHl.Sell_toCustomerNo) Then
    nfCustomer.Init
    nfCustomer(tCustomer.No) = myHl.Sell_toCustomerNo
    nfCustomer(tCustomer.Name) = myHl.Bill_toAddress
    nfCustomer(tCustomer.Name2) = myHl.Bill_toName2
    nfCustomer(tCustomer.Contact) = myHl.Bill_toContact
    nfCustomer(tCustomer.Address) = myHl.Bill_toAddress
    nfCustomer(tCustomer.Address2) = myHl.Bill_toAddress2
    nfCustomer(tCustomer.PostCode) = myHl.Bill_toPostCode
    nfCustomer(tCustomer.City) = myHl.Bill_toCity
   'Czech - nfCustomer("IO") = myHl.PlatceICO                                 'Only for Czech version!
    nfCustomer(tCustomer.VATRegistrationNo) = myHl.VATRegistrationNo
    nfCustomer(tCustomer.Gen_Bus_PostingGroup) = myHl.Gen_Bus_PostingGroup
    nfCustomer(tCustomer.VATBus_PostingGroup) = myHl.VATBus_PostingGroup
    nfCustomer(tCustomer.CustomerPostingGroup) = myHl.CustomerPostingGroup
    Call nfCustomer.Insert(True)
  End If
  
  Call nfSalesHeader.Validate(tSalesHeader.Sell_toCustomerNo, myHl.Sell_toCustomerNo)
  
  nfSalesHeader(tSalesHeader.Bill_toName) = myHl.Bill_toName
  nfSalesHeader(tSalesHeader.Bill_toName2) = myHl.Bill_toName2
  nfSalesHeader(tSalesHeader.Bill_toContact) = myHl.Bill_toContact
  nfSalesHeader(tSalesHeader.Bill_toAddress) = myHl.Bill_toAddress
  nfSalesHeader(tSalesHeader.Bill_toAddress2) = myHl.Bill_toAddress2
  nfSalesHeader(tSalesHeader.Bill_toPostCode) = myHl.Bill_toPostCode
  nfSalesHeader(tSalesHeader.Bill_toCity) = myHl.Bill_toCity
 'Czech - nfSalesHeader("IO") = myHl.PlatceICO                                'Only for Czech version!
  nfSalesHeader(tSalesHeader.VATRegistrationNo) = myHl.VATRegistrationNo

  Call nfSalesHeader.Validate(tSalesHeader.OrderDate, myHl.OrderDate)
  nfSalesHeader(tSalesHeader.ShipmentDate) = myHl.ShipmentDate
  Call nfSalesHeader.Validate(tSalesHeader.DueDate, myHl.DatumSplatnosti)

 'Czech CP nfSalesHeader("Datum expirace") = myHl.DatumExpirace               'Only Computer Press
  
  nfSalesHeader(tSalesHeader.SalespersonCode) = myHl.SalespersonCode
  
'xx  Call nfSalesHeader.Validate(tSalesHeader.PaymentTermsCode, myHl.PaymentTermsCode)
'xx  Call nfSalesHeader.Validate(tSalesHeader.ShipmentMethodCode, myHl.ShipmentMethodCode)
  
'xx  Call nfSalesHeader.Validate(tSalesHeader.LocationCode, myHl.LocationCode)
'xx  Call nfSalesHeader.Validate(tSalesHeader.DepartmentCode, myHl.DepartmentCode)
'xx  Call nfSalesHeader.Validate(tSalesHeader.ProjectCode, myHl.ProjectCode)
  
  nfSalesHeader(tSalesHeader.Ship_toName) = myHl.Ship_toName
  nfSalesHeader(tSalesHeader.Ship_toName2) = myHl.Ship_toName2
  nfSalesHeader(tSalesHeader.Ship_toContact) = myHl.Ship_toContact
  nfSalesHeader(tSalesHeader.Ship_toAddress) = myHl.Ship_toAddress
  nfSalesHeader(tSalesHeader.Ship_toAddress2) = myHl.Ship_toAddress2
  nfSalesHeader(tSalesHeader.Ship_toPostCode) = myHl.Ship_toPostCode
  nfSalesHeader(tSalesHeader.Ship_toCity) = myHl.Ship_toCity
  nfSalesHeader(tSalesHeader.Ship_toCity) = "Blbkov"
  Call nfSalesHeader.Validate("sten dodvky?", 1)
  Call nfSalesHeader.Validate("Vytisknout", True)
  
  'Next fields is only for Computer Press
  If False Then
    nfSalesHeader("Dodac telefon") = myHl.DodaciTelefon
    nfSalesHeader("Vyizuje") = myHl.KodVyrizuje
  
    nfSalesHeader("Zaadit do fronty") = 1 'BrnoHl
    nfSalesHeader("Stav - distribuce") = 0  'Edit,Wait-Platba,Wait-Expedice,Vltava,VypalCD,Abonence,Pozastaveno,Timeout,,,NAVI,LAMA
    nfSalesHeader("Odkud je objednvka?") = 1  'Vltava
  End If
  Call nfSalesHeader.Insert(True)
End Sub

Public Sub InsertProdR(ByRef myHl As ProdHlav, ByRef myR As ProdRadek)
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'      Popis: Vlo do Navision Financials jeden dek objednvky
'
'  Parametry: MyR  - Pole dk objednvky.
'                    Me jich bt teoreticky neomezen mnostv
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Dim nfSalesLine As New FinX.Table
    Set nfSalesLine = NF.AllocTable(37)
    
    nfSalesLine(tSalesLine.DocumentType) = myHl.DocumentType
    nfSalesLine(tSalesLine.DocumentNo) = myHl.No
    nfSalesLine(tSalesLine.LineNo) = myR.LineNo
    '-----------------------------------
    Call nfSalesLine.Validate(tSalesLine.Type_, myR.Type_)
    Call nfSalesLine.Validate(tSalesLine.No, myR.No)
    
    'POZOR! Celkov "stka s DPH" a "Mnostv" jsou nejsvatj sla a je
    'neppustn je jakkoli pepotvat. Mus odpovdat tomu co se dozvdl
    'zkaznk na webu.
    'Samozejm pokud se m mysln objednvka upravit (teba nen zbo) pak je lze zmnit.
    'Nikoli vak z dvodu zaokrouhlen a podobn.
    'Kusov cena, sleva a podobn sla jsou pouze doplky!
    
    Call nfSalesLine.Validate(tSalesLine.Quantity, myR.Quantity)

    If myR.UnitPriceIncludesVAT Then
      Call nfSalesLine.Validate(tSalesLine.UnitPrice, Round(myR.UnitPrice / (1 + nfSalesLine(tSalesLine.VATp) / 100), 2))
    Else
      Call nfSalesLine.Validate(tSalesLine.UnitPrice, myR.UnitPrice)
    End If
    
    If myR.Quantity <> 0 Then
      If (myR.AmountIncludingVAT <> 0) And (myR.UnitPrice = 0) Then
        Call nfSalesLine.Validate(tSalesLine.UnitPrice, Round((myR.AmountIncludingVAT / myR.Quantity) / (1 + nfSalesLine(tSalesLine.VATp) / 100), 2))
      End If
      
      If myR.AmountIncludingVAT = 0 Then
        Call nfSalesLine.Validate(tSalesLine.UnitPrice, 0)
      Else
        Call nfSalesLine.Validate(tSalesLine.AmountIncludingVAT, myR.AmountIncludingVAT)
      End If
    End If

    'Pokud nen lokace, stedisko nebo skupina tak se pouij daje uveden v hlavice (nfSalesHeader)
    If myR.LocationCode <> "" Then Call nfSalesLine.Validate(tSalesLine.LocationCode, myR.LocationCode)
    If myR.DepartmentCode <> "" Then Call nfSalesLine.Validate(tSalesLine.DepartmentCode, myR.DepartmentCode)
    If myR.ProjectCode <> "" Then Call nfSalesLine.Validate(tSalesLine.ProjectCode, myR.ProjectCode)
    
    If myR.Description <> "" Then nfSalesLine(tSalesLine.Description) = myR.Description 'Pokud nen uvedeno tak zstatane popis z karty v NF
        
    Call nfSalesLine.Insert(True)
End Sub

Public Sub InsertZbozi(ByRef myItem As Zbozi)
  Dim nfZbozi As FinX.Table
  Set nfZbozi = NF.AllocTable(27) 'Zbo
  
  nfZbozi.Init
  nfZbozi(tItem.No) = myItem.No
  
  nfZbozi(tItem.No_2) = myItem.SearchName  'V CP pouito jako "ISBN"
  nfZbozi(tItem.SearchDescription) = myItem.No2      'V CP pouito jako "rov kd"
  
  nfZbozi(tItem.InventoryPostingGroup) = myItem.InventoryPostingGroup
  nfZbozi(tItem.Gen_Prod_PostingGroup) = myItem.Gen_Prod_PostingGroup
  nfZbozi(tItem.VATBus_PostingGr_Price) = myItem.VATBus_PostingGr_Price
  nfZbozi(tItem.VATProd_PostingGroup) = myItem.VATProd_PostingGroup

  nfZbozi(tItem.Description) = myItem.Name
  
  nfZbozi(tItem.PriceIncludesVAT) = myItem.UnitPriceIncludesVAT
  nfZbozi(tItem.UnitPrice) = Round(myItem.UnitPrice, 2)
  nfZbozi(tItem.UnitListPrice) = Round(myItem.UnitListPrice, 2)  'Pouze CP
  
  nfZbozi(tItem.VendorNo) = myItem.VendorNo
  nfZbozi(tItem.VendorItemNo) = myItem.VendorItemNo
  nfZbozi(tItem.GrossWeight) = myItem.NetWeight
  nfZbozi(tItem.NetWeight) = myItem.NetWeight
  
  Call nfZbozi.Insert
End Sub

Public Function ChangedInventory(ByVal ItemNo As String, Optional ByVal Location As Variant)
  'Funkce je zavolna pokad kdy je detekovna zmna stavu zsob
  '---------------------------------------------------------------------------------------------------
  If IsMissing(Location) Then
    Debug.Print "Inventory " & ItemNo & " is changed"
  Else
    Debug.Print "Inventory " & ItemNo & " on location " & Location & " is changed"
  End If
End Function

Public Sub TestChangeInventory(Optional ByVal ByLocation As Boolean = False)
  Dim nfItemEntry As FinX.Table
  Dim lngLastEntry As Long
  Dim strBuff As String
  Dim strItemNo As String
  Dim strLocation As String
  Dim strItemNoBuff As String
  Dim I As Long
  
  lngLastEntry = CLng("0" & clsIniFile.LoadFromINI("Counters", "LastItemInventory"))
  Set nfItemEntry = NF.AllocTable(32) 'Item Ledger Entry
  Call nfItemEntry.SetCurrentKey(1)  'Entry No.
  Call nfItemEntry.SetFilter(1, ">0" & lngLastEntry)
  If nfItemEntry.Find("-") Then
    Do
      I = I + 1
      strItemNo = nfItemEntry(2) 'Item No.
      If ByLocation Then
        strLocation = nfItemEntry(8) 'Location Code
        strItemNoBuff = strItemNo & "-" & strLocation & "`"
      Else
        strItemNoBuff = strItemNo & "`"
      End If
    
      If InStr(strBuff, strItemNoBuff) = 0 Then
        strBuff = strBuff & strItemNo & "`"
        If ByLocation Then
          Call ChangedInventory(strItemNo, strLocation)
        Else
          Call ChangedInventory(strItemNo)
        End If
      End If
    Loop While (nfItemEntry.NextRec > 0) And (I < 20)
    lngLastEntry = nfItemEntry(1)
    Call clsIniFile.SaveToINI("Counters", "LastItemInventory", lngLastEntry)
  End If
End Sub

Public Sub Connect()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'      Popis: Zajist pipojen k databzi/serveru Navision Financials
'             Funkce zrove inicializuje potebn objekty
'
'  Parametry: Potebn daje si bere z INI souboru

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
   If TypeName(NF) = "Nothing" Then
     clsIniFile.FileName = "FinXDemo.ini"
     Set NF = New FinX.Database
     Call NF.Disconnect(stopNow) '?????
     Call NF.AutoConnect("d:\data\vb\finx\finx.ini")
   End If
   NF.SelectLatestVersion
End Sub

Public Sub Disconnect()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'      Popis: Zajist odpojen od databze/serveru Navision Financials
'             Uvoln ji nepotebn objekty
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  If TypeName(NF) <> "Nothing" Then
    Call NF.Disconnect(Now)
    Set NF = Nothing
  End If
End Sub

