VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIniFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'       Popis: Objekt pracuje s daty uloenmi v INI souboru
'
'       Autor: Tom vec
'
'  References: Kernel32.dll
'
'     Pouit: Program VB\EBM\Servis
'
'
' Mon chyby:  10101 - Chyba pi ten z INI souboru.
'               10102 - Chyba pi zpisu do INI souboru.
'
'    Historie: 06.11.2000 - Vytvoen - podle vzoru neznmho autora - staeno z Internetu
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

Private Declare Function WritePrivateProfileString _
                 Lib "kernel32" _
                 Alias "WritePrivateProfileStringA" _
                   (ByVal lpApplicationname As String, _
                    ByVal lpKeyName As Any, _
                    ByVal lsString As Any, _
                    ByVal lplFilename As String _
                   ) As Long

Private Declare Function GetPrivateProfileString _
                 Lib "kernel32" _
                 Alias "GetPrivateProfileStringA" _
                   (ByVal lpApplicationname As String, _
                    ByVal lpKeyName As String, _
                    ByVal lpDefault As String, _
                    ByVal lpReturnedString As String, _
                    ByVal nSize As Long, _
                    ByVal lpFileName As String _
                   ) As Long

'---------------------------------------------------------------------------------------------------
Private strFileName As String 'Uchovv pln nzev v INI souboru
Private Const strDefaultTxt As String = "DefaultValue%KeyIsNotExist"
'---------------------------------------------------------------------------------------------------
Property Let FileName(FileName As String)
  If InStr(FileName, "\") = 0 Then FileName = App.Path & "\" & FileName
  strFileName = FileName
End Property
   
Property Get FileName() As String
  FileName = strFileName
End Property

Public Function LoadFromINI(ByVal KeySection As String, ByVal KeyKey As String, Optional Povinne As Boolean = False) As String
  Dim lngResult As Long
  Dim strResult As String * 500
  Dim strDefault As String

  strDefault = strDefaultTxt
  lngResult = GetPrivateProfileString(KeySection, KeyKey, strDefault, strResult, Len(strResult), strFileName)
  
  If (lngResult = 0) And Povinne Then
    Err.Raise 10101, , "Chyba pi ten z INI souboru " & strFileName & ". Sekce='" & KeySection & "', Kl='" & KeyKey & "'."
  End If
  LoadFromINI = strResult
  If InStr(LoadFromINI, Chr(0)) > 0 Then LoadFromINI = Left(LoadFromINI, InStr(LoadFromINI, Chr(0)) - 1)
  If LoadFromINI = strDefaultTxt Then LoadFromINI = ""
End Function

Public Function SaveToINI(ByVal KeySection As String, ByVal KeyKey As String, ByVal KeyValue As String)
  Dim lngResult As Long
  lngResult = WritePrivateProfileString(KeySection, KeyKey, KeyValue, strFileName)
  If lngResult = 0 Then
    Err.Raise 10102, , "Chyba pi zpisu do INI souboru " & strFileName & ". Sekce='" & KeySection & "', Kl='" & KeyKey & "'."
  End If
End Function

